## mongo-c-driver 1.14.1

=== build/requirements.txt ===
jinja2
GitPython
git+https://github.com/mongodb-labs/drivers-evergreen-tools#subdirectory=evergreen_config_generator&egg=evergreen_config_generator
