=== src/libmongoc/doc/man/CMakeLists.txt ===
set_dist_list (src_libmongoc_doc_man_DIST
   CMakeLists.txt
)
