=== debian/changelog ===
mongo-c-driver (1.14.1-1) unstable; urgency=medium

  * New upstream release
  * Update to Standards-Version 4.4.0 (no changes)

 -- Roberto C. Sanchez <roberto@connexer.com>  Fri, 09 Aug 2019 16:43:32 -0400
